#include "io430.h"
#include <stdbool.h>
#include "speaker.h"

#define COUNT

#ifdef COUNT
int count = 0;
#endif

void bubblesort(int x[], int length)
{
  bool isSorted = false;
  while(!isSorted)
  {
    isSorted = true;
    for(int i = 0; i < length - 1; i++)
    // Ggf. knnte man mit einem hheren Wert als 0 anfangen.
    // Auerdem ist der Wert am Ende schon nach dem ersten Durchgang korrekt,
    // so dass man danach nicht mehr bis zum Ende laufen msste. Entsprechend
    // weniger in spteren Durchgngen.
    {
#ifdef COUNT
      count++;
#endif      
      if(x[i] > x[i + 1])
      {
        int a = x[i];
        x[i] = x[i + 1];
        x[i + 1] = a;
        isSorted = false;
      }
    }
    for(int i = 0; i < length; i++)
    {
      sound(x[i]);
    }
    sound(0);
  }
}

void selectionsort(int x[], int length)
{
  for(int i = 0; i < length - 1; i++)
  {
    int min = x[i];
    int minIndex = i;
    for(int j = i + 1; j < length; j++)
    {
#ifdef COUNT
      count++;
#endif      
      if(x[j] < min)
      {
        min = x[j];
        minIndex = j;
      }
    }
    x[minIndex] = x[i];
    x[i] = min;
    
    for(int j = 0; j < length; j++)
    {
      sound(x[j]);
    }
    sound(0);    
  }
}

void quicksort(int x[], int length)
{
  if(length <= 1)
  {
    return;
  }
  
  int pivot = x[0];
  int split = 1; // wird die Nummer des ersten Eintrags, der >= pivot ist (ohne pivot selbst)
  for(int i = 1; i < length; i++)
  {
#ifdef COUNT
    count++;
#endif
    if (x[i] < pivot)
    {
      int a = x[i];
      x[i] = x[split];
      x[split] = a;
      split++;
    }
  }

  int a = x[0];
  x[0] = x[split - 1];
  x[split - 1] = a;

  for(int i = 0; i < length; i++)
  {
    sound(x[i]);
  }
  sound(0);

  quicksort(x, split - 1);
  quicksort(x + split, length - split);
}

int numItems = 13;
int items[] = {622, 880, 554, 587, 440, 698, 740, 831, 523, 659, 784, 466, 494};

int main(void)
{
  initialize();

  bubblesort(items, numItems);
  //selectionsort(items, numItems);
  //quicksort(items, numItems);
  
  for(int i = 0; i < numItems; i++)
  {
    sound(items[i]);
  }
  
  return 0;
}
